//
//  gcc ms.c -oms.o -lncurses
//
#include  <stdlib.h>
#include  <errno.h>
#include  <sys/types.h>
#include  <sys/ipc.h>
#include  <sys/sem.h>
#include  <signal.h>
#include  <ncurses.h>

#define PERM        0660          // prawa dostepu
#define KLUCZ_SEM   (key_t)1232
#define KLUCZ_MEM   (key_t)0x10


//---- struktura dla semaforow ------------
      
union semun {
  int val;
  struct semi_ds *buf;
  unsigned short *array;
}; 

int id_sem, id_mem, ww, i, k=0; 
int *adres;
 
//---- funkcja usuwa zestaw semaforow ---- 

int usun_sem(int id) {
  union semun unia_sem;
  
  if (semctl(id, 0, IPC_RMID, unia_sem) == -1) {
    perror("\n    S. SEM_RMID error ");
    return(-1);
  }
  return(0);
}
 

//---- funkcja ustawiajaca wartosc semafora ---- 

int ustaw_sem(int id, int nr, int wart) {

  union semun unia_sem;
  unia_sem.val = wart;
  
  if ((semctl(id, nr, SETVAL, unia_sem)) == -1) {
    perror("\n    S. SETVAL error ");
    return(-1);
  }
  return(0);
}

//---- funkcja wykonuje operacje na semaforze ----

int sem_oper(int id, short nr, short wart) {
  struct sembuf buf_sem;
     
  buf_sem.sem_num = nr;
  buf_sem.sem_op = wart;
  buf_sem.sem_flg = 0;
  if ((semop(id, &buf_sem, 1)) == -1) {
    perror("\n     K. SEMOP error  ");
    return(-1);
  }
  return(0); 
}


void koniec() {
  
  curs_set(1);
  clear();
  refresh();
  endwin();
      
  if(shmctl(id_mem, IPC_RMID, NULL) == -1)    
        perror("\n   S. MEM_RMID error  ");
  
  usun_sem(id_sem);
 
  printf("\n      Ctrl_C Serwera\n\n");
  exit(EXIT_SUCCESS);
} 

int main(void) {
  
  signal(SIGINT, koniec); 
      
  if ((id_sem=semget(KLUCZ_SEM, 1, PERM | IPC_CREAT | IPC_EXCL))==-1) {
     perror("\n   S. SEM_CREAT error  ");
     exit(EXIT_FAILURE);
  }   
  if ((id_mem=shmget(KLUCZ_MEM, 2*sizeof(int), PERM | IPC_CREAT | IPC_EXCL))==-1) {
     perror("\n   S. MEM_CREAT error  ");
     usun_sem(id_sem);
     exit(EXIT_FAILURE);
  } 
  if ((adres = (int *)shmat(id_mem,0, 0)) == ((int *)-1)) {
     perror("\n   S. MEM_SHMAT error  ");
     usun_sem(id_sem);
     if(shmctl(id_mem, IPC_RMID, NULL) == -1)    
          perror("\n   S. MEM_RMID error  ");
     exit(EXIT_FAILURE); 
  } 
  initscr();
  curs_set(0);
  start_color();
  clear();
   
  move(1,10); 
  printw("   %d. Test wspolnej pamieci -  Koniec Ctrl_C ", id_mem);
  move(2,2); 
  printw("%s","  ----------------------------------------------------------");
  move(5,2); 
  printw("%s"," Pamiec    [0] =         [1] =               ");

  refresh();
  
  ustaw_sem(id_sem, 0, 1);
  
  while(1) { 
    sem_oper(id_sem,0,-1);
    ww = *(adres+0);
    move(5,19); printw("%d",ww);
    ww = *(adres+1);
    move(5,33); printw("%d",ww);
    sem_oper(id_sem,0,1);        
    k++; move(1,2); printw("%x", k); 
    refresh();   
    sleep(3);  
  }   
}

