//
//   gcc semk.c -osemk.o
//
#include  <unistd.h>
#include  <stdlib.h>
#include  <stdio.h>
#include  <errno.h>
#include  <sys/types.h>
#include  <sys/ipc.h>
#include  <sys/sem.h>
#include  <signal.h>

#define PERM  0660     // prawa dostepu
#define KLUCZ_SEM   (key_t)1232

//---- struktury dla semaforow ------------
      
typedef struct _my_data {
  short sem_num;
  short sem_op;
  short sem_flg;
} sembuf;


union semun {
  int val;
  struct semi_ds *buf;
  unsigned short *array;
}; 

//---- funkcja wykonuje operacje na semaforze ----

int sem_oper(int id, short nr, short wart) {
  struct sembuf buf_sem;
     
  buf_sem.sem_num = nr;
  buf_sem.sem_op = wart;
  buf_sem.sem_flg = 0;
  if ((semop(id, &buf_sem, 1)) == -1) {
    perror("\n     K. semop error  ");
    return(-1);
  }
  return(0); 
}


int main(int argc, char *argv[]) { 
  int id_sem, ww; 
  short nr, wart;
  if (argc<2) {
    printf("\n Brak argumentow :  numer[0..9], wartosc [-1,0,1] \n\n");
    exit(-1);
  } 
    nr=atoi(argv[1]);
  wart=atoi(argv[2]);
  
  if ((id_sem=semget(KLUCZ_SEM, 10, 0))==-1) {
     perror("\n   K. semget error  ");
     exit(-1);
  }   
  printf("\n %d. Start. Sem[%d] -> %d",id_sem, nr, wart);
  fflush(stdout);
  if ((sem_oper(id_sem, nr, wart)) == -1) exit(-1);
  printf("\n %d.Koniec. Sem[%d] -> %d\n",id_sem, nr, wart);
  fflush(stdout);
  return(0); 
}

