//
//  gcc sems.c -osems.o -lncurses
//
#include  <errno.h>
#include  <sys/types.h>
#include  <sys/ipc.h>
#include  <sys/sem.h>
#include  <signal.h>
#include  <ncurses.h>

#define PERM  0660         // prawa dostepu
#define KLUCZ_SEM   (key_t)1232


//---- struktura dla semaforow ------------
      
union semun {
  int val;
  struct semi_ds *buf;
  unsigned short *array;
}; 

int id_sem, ww, i, k=0; 

 
//---- funkcja usuwa zestaw semaforow ---- 

int usun_sem(int id) {
  union semun unia_sem;
  
  if (semctl(id, 0, IPC_RMID, unia_sem) == -1) {
    perror("\n    S. IPC_RMID error ");
    return(-1);
  }
  return(0);
}
 

//---- funkcja ustawiajaca wartosc semafora ---- 

int ustaw_sem(int id, int nr, int wart) {

  union semun unia_sem;
  unia_sem.val = wart;
  
  if ((semctl(id, nr, SETVAL, unia_sem)) == -1) {
    perror("\n    S. SETVAL error ");
    return(-1);
  }
  return(0);
}

//---- funkcja zwracajaca wartosc semafora ---- 

int odczyt_sem(int id, int nr){
  union semun unia_sem;
  int www;
  if((www = semctl(id, nr, GETVAL, unia_sem)) == -1) {
    perror("\n    S. GETVAL error ");
    return(-1);
  }
  return(www);
}


void koniec() {
  
  curs_set(1);
  clear();
  refresh();
  endwin();
  
  usun_sem(id_sem);
 
  printf("\n      Ctrl_C Serwera\n\n");
  exit(0);
} 

int main(void) {
  
  signal(SIGINT, koniec); 
      
  if ((id_sem=semget(KLUCZ_SEM, 10, PERM | IPC_CREAT | IPC_EXCL))==-1) {
     perror("\n   S. IPC_CREAT error  ");
     exit(-1);
  }   
   
  initscr();
  curs_set(0);
  start_color();
  clear();
   
  move(1,10); 
  printw("       %d. Test semaforów -  Koniec Ctrl_C ", id_sem);
  move(3,2); 
  printw("%s"," Numer Semafora     0   1   2   3   4   5   6   7   8   9 ");
  move(4,2); 
  printw("%s","                   ----------------------------------------");
  move(5,2); 
  printw("%s"," Wartosc ");

  refresh();
  
  for (i=0; i<10; i++) ustaw_sem(id_sem, i, 2);
  
  while(1){ 
    move(5,22);
    for (i=0; i<10; i++) {
     ww=odczyt_sem(id_sem, i); 
     printw("%1d   ",ww);    
    }
    k++; move(1,2); printw("%x", k); 
    refresh();   
    sleep(5);  
  } 
  retrun (0);  
}

