//
//  gcc watek.c -owatek.o -lncurses -lpthread
//
#include  <unistd.h>
#include  <stdlib.h>
#include  <stdio.h>
#include  <errno.h>
#include  <ctype.h>
#include  <sys/types.h>
#include  <sys/ipc.h>
#include  <sys/sem.h>
#include  <signal.h>
#include  <ncurses.h>
#include  <pthread.h>

#define PERM        0660          // prawa dostepu
#define KLUCZ_SEM   (key_t)11


//---- struktura dla semaforow ------------
      
union semun {
  int val;
  struct semi_ds *buf;
  unsigned short *array;
}; 

int id_sem, kon, wx,wy, wx1,wy1;
unsigned int k=0; 
char zn,zn1;
 
//---- funkcja usuwa zestaw semaforow ---- 

int usun_sem(int id) {
  union semun unia_sem;
  
  if (semctl(id, 0, IPC_RMID, unia_sem) == -1) {
    perror("\n    S. SEM_RMID error ");
    return(-1);
  }
  return(0);
}
 

//---- funkcja ustawiajaca wartosc semafora ---- 

int ustaw_sem(int id, int nr, int wart) {

  union semun unia_sem;
  unia_sem.val = wart;
  
  if ((semctl(id, nr, SETVAL, unia_sem)) == -1) {
    perror("\n    S. SETVAL error ");
    return(-1);
  }
  return(0);
}

//---- funkcja wykonuje operacje na semaforze ----

int sem_oper(int id, short nr, short wart) {
  struct sembuf buf_sem;
     
  buf_sem.sem_num = nr;
  buf_sem.sem_op = wart;
  buf_sem.sem_flg = 0;
  if ((semop(id, &buf_sem, 1)) == -1) {
    perror("\n     K. SEMOP error  ");
    return(-1);
  }
  return(0); 
}


// ---- funkcja obslugi watku  ----


void *wysw_w () {
    sem_oper(id_sem,0,-1);
    move(wy1,wx1); printw("%c",zn1); 
    refresh();   
    sem_oper(id_sem,0,1);            
    zn1++; if (zn1=='{') zn='a';
    wx1++; if (wx1>60) wx1=1; 
    sleep(1);
    sem_oper(id_sem,0,-1);
    move(wy1,wx1); printw("%c",zn1); 
    refresh();   
    sem_oper(id_sem,0,1);            
    zn1++; if (zn1=='{') zn='a';
    wx1++; if (wx1>60) wx1=1; 
    sleep(1);
    sem_oper(id_sem,0,-1);
    move(wy1,wx1); printw("%c",zn1); 
    refresh();   
    sem_oper(id_sem,0,1);            
    zn1++; if (zn1=='{') zn='a';
    wx1++; if (wx1>60) wx1=1; 
    sleep(1);
}

// ---- funkcja obslugi sygnalu Ctrl_C ----

void koniec() {
  kon=0;
}



int main(void) {

pthread_t  www;
  
  signal(SIGINT, koniec); 
      
  if ((id_sem=semget(KLUCZ_SEM, 1, PERM | IPC_CREAT | IPC_EXCL))==-1) {
     perror("\n   S. SEM_CREAT error  ");
     exit(EXIT_FAILURE);
  }   

  initscr();
  curs_set(0);
  start_color();
  clear();
   
  move(1,10); 
  printw("     Watki  -  Koniec Ctrl_C ");
  move(5,1); 
  printw("%s","-------------------------------------------------------------");
  refresh();
  
  ustaw_sem(id_sem, 0, 1);
  
  wx=1,  wy=7;  zn='A';  
  wx1=1, wy1=4; zn1='a';  
  kon=1;
  while(kon) { 
    sem_oper(id_sem,0,-1);
    move(wy,wx); printw("%c",zn); 
    refresh();   
    sem_oper(id_sem,0,1);        
    
    zn++; if (zn=='[') zn='A';
    wx++; if (wx>60) {
       wx=1; wy++; 
       if (wy>14) wy=7;
    }   
    k++; sleep(1);
    sem_oper(id_sem,0,-1);        
    move(1,2); printw("%d", k); 
    refresh();   
    sem_oper(id_sem,0,1);        
    if ((k % 5)==0) 
      pthread_create( &www, NULL, wysw_w, NULL);      
  } 

  curs_set(1);
  clear();
  refresh();
  endwin();
      
  usun_sem(id_sem);
  printf("\n      Ctrl_C  Watki \n\n");
  exit(EXIT_SUCCESS);
}

